/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.informes.egresos;

import danielcortes.xyz.data.SQLiteConnectionHolder;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public class SQLiteInformeEgresosContentDAO extends InformeEgresosContentDAO {
    private static final Logger LOGGER = Logger.getLogger(InformeEgresosContentDAO.class.getName());

    private List<InformeEgresosContent> list;

    public SQLiteInformeEgresosContentDAO() {
        this.connectionHolder = new SQLiteConnectionHolder();
    }

    @Override
    public List<InformeEgresosContent> getInformeEgresosFactuasMateriaPrima(LocalDate date, int tipoEgresoId) {
        list = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {

            String query = "select caja.fecha as \"fecha\"," +
                    "egresos.nro as \"nro\"," +
                    "egresos.descripcion as \"descripcion\"," +
                    "egresos.valor as \"valor\"" +
                    "from egresos inner join caja on egresos.caja_id = caja.id " +
                    "where caja.fecha between date(?) and date(?) and egresos.tipo_egreso_id = ? " +
                    "order by caja.fecha;";

            PreparedStatement ps = conn.prepareStatement(query);
            ps.setString(1, date.withDayOfMonth(1).toString());
            ps.setString(2, date.withDayOfMonth(date.lengthOfMonth()).toString());
            ps.setInt(3, tipoEgresoId);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: [{1},{2},{3}]", new Object[]{date.withDayOfMonth(1), date.withDayOfMonth(date.lengthOfMonth()), tipoEgresoId});

            this.fillInforme(rs);
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return list;
    }

    private void fillInforme(ResultSet rs) throws SQLException {
        while (rs.next()) {
            InformeEgresosContent content = new InformeEgresosContent();
            content.setFecha(LocalDate.parse(rs.getString("fecha")));
            content.setDescripcion(rs.getString("descripcion"));
            content.setNro(rs.getString("nro"));
            content.setValor(rs.getInt("valor"));
            LOGGER.log(Level.FINER, "Se a creado: {0}", content);
            list.add(content);
        }
    }
}
